var translate_load_div = undefined;
var google_translate_iframe = undefined; 
var set_target_language = undefined;
var select_language_div = undefined;
var language_select = undefined;
var canceled_translate = false;
var check_target_language_timer = undefined;
var tmp_target_language1 = 'en';
var tmp_target_language2 = 'ja';
var chick_close_button = false;
var debug_log_close = true;
function translatePrint(infor) {
    if (debug_log_close)
        return;

    if (typeof __injectionJavaScriptObject___ !== "undefined" && __injectionJavaScriptObject___.print) {
        __injectionJavaScriptObject___.print(infor);
    } else {
        var jesion = {"class_name": "com.ijinshan.browser.KInjectionJavaScriptObject", "params": {"function_name": "print","log": infor,}, "sync": false,};
        prompt(JSON.stringify(jesion), "3.1415926535");
    }
}

function getTranslateTargetLanguageCode() {
    if (typeof __injectionJavaScriptObject___ !== "undefined" && __injectionJavaScriptObject___.getTranslateTargetLanguageCode) {
        return __injectionJavaScriptObject___.getTranslateTargetLanguageCode();
    } else {
        var jesion = {"class_name": "com.ijinshan.browser.KInjectionJavaScriptObject", "params": {"function_name": "translateTargetLanguageCode",}, "sync": true,};
        jesion = prompt(JSON.stringify(jesion), "3.1415926535");
        jesion = JSON.parse(jesion);
        return jesion.translateTargetLanguageCode;
    }
}

function setTranslateTargetLanguageCode(language) {
    if (typeof __injectionJavaScriptObject___ !== "undefined" && __injectionJavaScriptObject___.setTranslateTargetLanguageCode) {
        __injectionJavaScriptObject___.setTranslateTargetLanguageCode(language);
    } else {
        var jesion = {"class_name": "com.ijinshan.browser.KInjectionJavaScriptObject", "params": {"function_name": "setTranslateTargetLanguageCode","translateTargetLanguageCode": language,}, "sync": true,};
        prompt(JSON.stringify(jesion), "3.1415926535");
    }
}

function getTranslateLoadingTip() {
    if (typeof __injectionJavaScriptObject___ !== "undefined" && __injectionJavaScriptObject___.getTranslateLoadingTip) {
        return __injectionJavaScriptObject___.getTranslateLoadingTip();
    } else {
        var jesion = {"class_name": "com.ijinshan.browser.KInjectionJavaScriptObject", "params": {"function_name": "translateLoadingTip",}, "sync": true,};
        jesion = prompt(JSON.stringify(jesion), "3.1415926535");
        jesion = JSON.parse(jesion);
        return jesion.translateLoadingTip;
    }
}
function googleTranslateElementInit() {
    translatePrint("googleTranslateElementInit");
    new google.translate.TranslateElement(
        {pageLanguage: '', layout: google.translate.TranslateElement.FloatPosition.TOP_LEFT},
        'google_translate_element');
    checkGoogleTranslateBar();
    checkLanguageSelect();
}

function checkGoogleTranslateBar() {
    translatePrint("checkGoogleTranslateBar");
    var find_google_translate_iframe_timer = setInterval(function() {
        google_translate_iframe = document.getElementById(':1.container');
        translatePrint("find_google_translate_iframe_timer google_translate_iframe=" + google_translate_iframe);
        if(google_translate_iframe && document.body.style.top == '40px') {
            clearInterval(find_google_translate_iframe_timer);
            hideLoadDiv();
            setGoogleTranslateBar();
        } else {
            google_translate_iframe = null;
        }
    }, 200);
}

function startCheckTargetLanguage() {
    if(typeof check_target_language_timer != 'undefined')
        return;
    translatePrint("check_target_language_timer create");
    check_target_language_timer = setInterval(function() {
        setTranslateTargetLanguageCode(language_select.value);
    }, 1000);
}

function stopCheckTargetLanguage() {
    if (typeof check_target_language_timer != 'undefined') {
        translatePrint("check_target_language_timer release");
        clearInterval(check_target_language_timer);
        check_target_language_timer = undefined;
    }
}

function setGoogleTranslateBar() {
    translatePrint("setGoogleTranslateBar");
    google_translate_iframe.style.position = 'relative';
    document.body.style.top = 0;

    var close_button = google_translate_iframe.contentDocument.querySelector('#\\:1\\.close');
    close_button.addEventListener('click', function(){
        chick_close_button = true;
    }, false);

    var close_menu_iframe = document.querySelectorAll('iframe.goog-te-menu-frame')[1];
    var clost_menu = close_menu_iframe.contentDocument.querySelectorAll('.goog-te-menu2-item')[1];
    clost_menu.addEventListener('click', function(){
        chick_close_button = true;
    }, false);

    if(canceled_translate)
        cancelTranslatePageDo();
}

function hideLoadDiv() {
    translate_load_div.style.display = 'none';
}

function checkLanguageSelect() {
    translatePrint("checkLanguageSelect");
    var find_language_select_timer = setInterval(function() {
        language_select = document.querySelector('.goog-te-combo');
        translatePrint("find_language_select_timer language_select=" + language_select);
        if (language_select && language_select.length > 0) {
            clearInterval(find_language_select_timer);
            setLanguageSelect();
        }
    }, 200);
}

function setLanguageSelect() {
    translatePrint("setLanguageSelect");
    function language_change_do() {
        translatePrint("language_select.value=" + language_select.value);
        translatePrint("set_target_language=" + set_target_language);
        if (canceled_translate)
            restoreTranslatePage();
        if (chick_close_button) {
            chick_close_button = false;
            document.body.style.top = 0;
        }
    }
    language_select.addEventListener('change', language_change_do, false);
    translateToTargetLanguageLater();
}

function translateToTargetLanguageLater() {
    setTimeout(function(){
        if(set_target_language != tmp_target_language1)
            selectTranslateLanguage(tmp_target_language1);
        else
            selectTranslateLanguage(tmp_target_language2);
        setTimeout(function(){
            selectTranslateLanguage(set_target_language);
            startCheckTargetLanguage();
        }, 100);
    }, 100);
}

function selectTranslateLanguage(language_code) {
    translatePrint("selectTranslateLanguage:" + language_code);
    language_select.value = language_code;
    var change_event = document.createEvent('HTMLEvents');
    change_event.initEvent('change', false, true);
    language_select.dispatchEvent(change_event);
}

function cancelTranslatePage() {
    canceled_translate = true;
    translate_load_div.style.display = 'none';
    if(google_translate_iframe)
        cancelTranslatePageDo();
    else
        return;
}

function cancelTranslatePageDo() {
    translatePrint("cancelTranslatePageDo");
    google_translate_iframe.style.display = 'none';
    restoreTranslatePage();
    select_language_div.style.display = 'none';
}

function restoreTranslatePage() {
    translatePrint("restoreTranslatePage");
    stopCheckTargetLanguage();
    var click_event = document.createEvent('HTMLEvents');
    click_event.initEvent('click', false, true);
    google_translate_iframe.contentDocument.querySelector('#\\:1\\.restore').dispatchEvent(click_event);
}

function addLoadDiv() {
    translate_load_div = document.createElement('div');
    translate_load_div.id='translate_load_div';
    translate_load_div.style.position = 'relative';
    translate_load_div.style.top = '0px';
    translate_load_div.style.left = '0px';
    translate_load_div.style.zIndex = '100000';
    translate_load_div.style.backgroundColor = '#FFFFFF';
    translate_load_div.style.width = '100%';
    translate_load_div.style.height = '73px';
    translate_load_div.style.borderBottomStyle = 'solid';
    translate_load_div.style.borderBottomColor = '#BFBFBF';
    translate_load_div.style.borderBottomWidth = '1px';

    translate_png_img = document.createElement('img');
    translate_png_img.style.position = 'absolute';
    translate_png_img.src = "liebiao/cmcm/translate.png";
    translate_png_img.style.top = '15px';
    translate_png_img.style.left = '19px';
    translate_png_img.style.width = '42px';
    translate_png_img.style.height = '42px';
    translate_load_div.appendChild(translate_png_img);

    translate_load_text_p = document.createElement('span');
    translate_load_text_p.textContent = getTranslateLoadingTip();
    translate_load_text_p.style.position = 'absolute';
    translate_load_text_p.style.top = '28px';
    translate_load_text_p.style.left = '78px';
    translate_load_text_p.style.fontSize = '17px';
    translate_load_text_p.style.color = '#000000';
    translate_load_div.appendChild(translate_load_text_p);

    bodyfirstNode=document.body.childNodes[0];
    document.body.insertBefore(translate_load_div, bodyfirstNode);
}
function googleTranslateLaod(){
    set_target_language = getTranslateTargetLanguageCode();
    addLoadDiv();

    translatePrint("insert meda_node");
    var meda_node = document.createElement('meta');
    meda_node.name = 'google-translate-customization';
    meda_node.content = '3fdd76b50a06aff8-1f12d71477f9a190-g73c7a42161787c14-21'; 
    document.head.appendChild(meda_node);

    translatePrint("insert language_div");
    select_language_div = document.createElement('div');
    select_language_div.id = 'google_translate_element';
    select_language_div.style.top = '100px';
    select_language_div.style.left = '10px';
    select_language_div.style.zIndex = '99999';
    bodyfirstNode=document.body.childNodes[0];
    document.body.insertBefore(select_language_div, bodyfirstNode);

    translatePrint("insert google_url_js");
    var translate_load_script = document.createElement('script');
    translate_load_script.type = 'text/javascript';
    translate_load_script.src = 'https://translate.google.com/translate_a/element.js?cb=googleTranslateElementInit';
    document.body.appendChild(translate_load_script);
};

googleTranslateLaod();

function translatePage(language) {
    canceled_translate = false;
    set_target_language = language;
    if(language_select) {
        startCheckTargetLanguage();
        selectTranslateLanguage(set_target_language);
        select_language_div.style.display = 'block';
        google_translate_iframe.style.display = 'block';
    }
}
